<?php

namespace OCA\Intros\Controller;

use OCP\AppFramework\Controller;
use OCP\IURLGenerator;
use OCP\IRequest;

use OCA\Intros\AppInfo\Application;
use OCP\AppFramework\Http\RedirectResponse;

class IntroController extends Controller
{
    private $urlGenerator;

    public function __construct(string $appName, IRequest $request, IURLGenerator $urlGenerator)
    {
        parent::__construct($appName, $request);
        $this->urlGenerator = $urlGenerator;
    }

    /**
     * @NoAdminRequired
     * @NoCSRFRequired
     */
    public function redirectToIntroOptions()
    {
        $url = $this->urlGenerator->linkToRouteAbsolute('settings.PersonalSettings.index', ['section' => Application::APP_ID]);
        return new RedirectResponse($url);
    }
}
