"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const r = require("vue"), o = require("./_plugin-vue2_normalizer-DNwUsAY0.cjs"), C = require("@nextcloud/files"), O = require("@nextcloud/l10n"), k = require("@nextcloud/vue"), M = require("@nextcloud/initial-state"), P = require("@nextcloud/router"), V = require("@vueuse/core"), Z = require("@nextcloud/axios"), j = require("@nextcloud/auth"), G = require("vue-frag"), I = require("@mdi/js"), W = require("@nextcloud/event-bus"), R = require("path"), D = require("cancelable-promise"), K = (l) => l && l.__esModule ? l : { default: l }, H = /* @__PURE__ */ K(Z), J = {
  name: "FileIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var Q = function() {
  var e = this, n = e._self._c;
  return n("span", e._b({ staticClass: "material-design-icon file-icon", attrs: { "aria-hidden": e.title ? null : !0, "aria-label": e.title, role: "img" }, on: { click: function(t) {
    return e.$emit("click", t);
  } } }, "span", e.$attrs, !1), [n("svg", { staticClass: "material-design-icon__svg", attrs: { fill: e.fillColor, width: e.size, height: e.size, viewBox: "0 0 24 24" } }, [n("path", { attrs: { d: "M13,9V3.5L18.5,9M6,2C4.89,2 4,2.89 4,4V20A2,2 0 0,0 6,22H18A2,2 0 0,0 20,20V8L14,2H6Z" } }, [e.title ? n("title", [e._v(e._s(e.title))]) : e._e()])])]);
}, X = [], Y = /* @__PURE__ */ o.normalizeComponent(
  J,
  Q,
  X,
  !1,
  null,
  null,
  null,
  null
);
const A = Y.exports, L = () => {
  const l = () => document.getElementById("isPublic")?.value === "1", e = r.ref(!0);
  return r.onBeforeMount(() => {
    e.value = l();
  }), {
    isPublic: e
  };
};
/**
 * @copyright Copyright (c) 2023 Ferdinand Thiessen <opensource@fthiessen.de>
 *
 * @author Ferdinand Thiessen <opensource@fthiessen.de>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
const T = () => {
  const l = M.loadState("files", "config", null), e = r.ref(l?.show_hidden ?? !0), n = r.ref(l?.sort_favorites_first ?? !0), t = r.ref(l?.crop_image_previews ?? !0), { isPublic: i } = L();
  return r.onMounted(async () => {
    if (i.value)
      console.debug("Skip loading files settings - currently on public share");
    else
      try {
        const { data: s } = await H.default.get(P.generateUrl("/apps/files/api/v1/configs"));
        e.value = s?.data?.show_hidden ?? !1, n.value = s?.data?.sort_favorites_first ?? !0, t.value = s?.data?.crop_image_previews ?? !0;
      } catch (s) {
        console.error("Could not load files settings", s), o.showError(o.t("Could not load files settings"));
      }
  }), {
    showHiddenFiles: e,
    sortFavoritesFirst: n,
    cropImagePreviews: t
  };
}, ee = (l) => {
  const e = (c) => c === "asc" ? "ascending" : c === "desc" ? "descending" : "none", n = M.loadState("files", "viewConfigs", null), t = r.ref({
    sortBy: n?.files?.sorting_mode ?? "basename",
    order: e(n?.files?.sorting_direction ?? "asc")
  }), i = r.ref({
    sortBy: n?.recent?.sorting_mode ?? "basename",
    order: e(n?.recent?.sorting_direction ?? "asc")
  }), s = r.ref({
    sortBy: n?.favorites?.sorting_mode ?? "basename",
    order: e(n?.favorites?.sorting_direction ?? "asc")
  }), { isPublic: a } = L();
  r.onMounted(async () => {
    if (a.value)
      console.debug("Skip loading files views - currently on public share");
    else
      try {
        const { data: c } = await H.default.get(P.generateUrl("/apps/files/api/v1/views"));
        t.value = {
          sortBy: c?.data?.files?.sorting_mode ?? "basename",
          order: e(c?.data?.files?.sorting_direction)
        }, s.value = {
          sortBy: c?.data?.favorites?.sorting_mode ?? "basename",
          order: e(c?.data?.favorites?.sorting_direction)
        }, i.value = {
          sortBy: c?.data?.recent?.sorting_mode ?? "basename",
          order: e(c?.data?.recent?.sorting_direction)
        };
      } catch (c) {
        console.error("Could not load files views", c), o.showError(o.t("Could not load files views"));
      }
  });
  const w = r.computed(() => V.toValue(l || "files") === "files" ? t.value : V.toValue(l) === "recent" ? i.value : s.value), v = r.computed(() => w.value.sortBy), d = r.computed(() => w.value.order);
  return {
    filesViewConfig: t,
    favoritesViewConfig: s,
    recentViewConfig: i,
    currentConfig: w,
    sortBy: v,
    order: d
  };
}, te = {
  name: "MenuUpIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var ne = function() {
  var e = this, n = e._self._c;
  return n("span", e._b({ staticClass: "material-design-icon menu-up-icon", attrs: { "aria-hidden": e.title ? null : !0, "aria-label": e.title, role: "img" }, on: { click: function(t) {
    return e.$emit("click", t);
  } } }, "span", e.$attrs, !1), [n("svg", { staticClass: "material-design-icon__svg", attrs: { fill: e.fillColor, width: e.size, height: e.size, viewBox: "0 0 24 24" } }, [n("path", { attrs: { d: "M7,15L12,10L17,15H7Z" } }, [e.title ? n("title", [e._v(e._s(e.title))]) : e._e()])])]);
}, ie = [], re = /* @__PURE__ */ o.normalizeComponent(
  te,
  ne,
  ie,
  !1,
  null,
  null,
  null,
  null
);
const se = re.exports, le = {
  name: "MenuDownIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var oe = function() {
  var e = this, n = e._self._c;
  return n("span", e._b({ staticClass: "material-design-icon menu-down-icon", attrs: { "aria-hidden": e.title ? null : !0, "aria-label": e.title, role: "img" }, on: { click: function(t) {
    return e.$emit("click", t);
  } } }, "span", e.$attrs, !1), [n("svg", { staticClass: "material-design-icon__svg", attrs: { fill: e.fillColor, width: e.size, height: e.size, viewBox: "0 0 24 24" } }, [n("path", { attrs: { d: "M7,10L12,15L17,10H7Z" } }, [e.title ? n("title", [e._v(e._s(e.title))]) : e._e()])])]);
}, ae = [], ce = /* @__PURE__ */ o.normalizeComponent(
  le,
  oe,
  ae,
  !1,
  null,
  null,
  null,
  null
);
const ue = ce.exports, U = {
  "file-picker__file-icon": "_file-picker__file-icon_1vgv4_5"
}, de = /* @__PURE__ */ r.defineComponent({
  __name: "LoadingTableRow",
  props: {
    showCheckbox: { type: Boolean }
  },
  setup(l) {
    return { __sfc: !0, fileListIconStyles: U };
  }
});
var fe = function() {
  var e = this, n = e._self._c, t = e._self._setupProxy;
  return n("tr", { staticClass: "file-picker__row loading-row", attrs: { "aria-hidden": "true" } }, [e.showCheckbox ? n("td", { staticClass: "row-checkbox" }, [n("span")]) : e._e(), n("td", { staticClass: "row-name" }, [n("div", { staticClass: "row-wrapper" }, [n("span", { class: t.fileListIconStyles["file-picker__file-icon"] }), n("span")])]), e._m(0), e._m(1)]);
}, pe = [function() {
  var l = this, e = l._self._c;
  return l._self._setupProxy, e("td", { staticClass: "row-size" }, [e("span")]);
}, function() {
  var l = this, e = l._self._c;
  return l._self._setupProxy, e("td", { staticClass: "row-modified" }, [e("span")]);
}], _e = /* @__PURE__ */ o.normalizeComponent(
  de,
  fe,
  pe,
  !1,
  null,
  "6aded0d9",
  null,
  null
);
const me = _e.exports;
/**
 * @copyright Copyright (c) 2023 Ferdinand Thiessen <opensource@fthiessen.de>
 *
 * @author Ferdinand Thiessen <opensource@fthiessen.de>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
function ve(l, e = {}) {
  e = { size: 32, cropPreview: !1, mimeFallback: !0, ...e };
  try {
    const n = l.attributes?.previewUrl || P.generateUrl("/core/preview?fileId={fileid}", {
      fileid: l.fileid
    });
    let t;
    try {
      t = new URL(n);
    } catch {
      t = new URL(n, window.location.origin);
    }
    return t.searchParams.set("x", `${e.size}`), t.searchParams.set("y", `${e.size}`), t.searchParams.set("mimeFallback", `${e.mimeFallback}`), t.searchParams.set("a", e.cropPreview === !0 ? "0" : "1"), t.searchParams.set("c", `${l.attributes.etag}`), t;
  } catch {
    return null;
  }
}
const ge = {
  name: "FolderIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var he = function() {
  var e = this, n = e._self._c;
  return n("span", e._b({ staticClass: "material-design-icon folder-icon", attrs: { "aria-hidden": e.title ? null : !0, "aria-label": e.title, role: "img" }, on: { click: function(t) {
    return e.$emit("click", t);
  } } }, "span", e.$attrs, !1), [n("svg", { staticClass: "material-design-icon__svg", attrs: { fill: e.fillColor, width: e.size, height: e.size, viewBox: "0 0 24 24" } }, [n("path", { attrs: { d: "M10,4H4C2.89,4 2,4.89 2,6V18A2,2 0 0,0 4,20H20A2,2 0 0,0 22,18V8C22,6.89 21.1,6 20,6H12L10,4Z" } }, [e.title ? n("title", [e._v(e._s(e.title))]) : e._e()])])]);
}, ye = [], we = /* @__PURE__ */ o.normalizeComponent(
  ge,
  he,
  ye,
  !1,
  null,
  null,
  null,
  null
);
const q = we.exports, Ce = {
  name: "FilePreview"
}, be = /* @__PURE__ */ r.defineComponent({
  ...Ce,
  props: {
    node: null,
    cropImagePreviews: { type: Boolean }
  },
  setup(l) {
    const e = l, n = r.ref(U), t = r.computed(() => ve(e.node, { cropPreview: e.cropImagePreviews })), i = r.computed(() => e.node.type === C.FileType.File), s = r.ref(!1);
    return r.watch(t, () => {
      if (s.value = !1, t.value) {
        const a = document.createElement("img");
        a.src = t.value.href, a.onerror = () => a.remove(), a.onload = () => {
          s.value = !0, a.remove();
        }, document.body.appendChild(a);
      }
    }, { immediate: !0 }), { __sfc: !0, fileListIconStyles: n, props: e, previewURL: t, isFile: i, canLoadPreview: s, IconFile: A, IconFolder: q };
  }
});
var ke = function() {
  var e = this, n = e._self._c, t = e._self._setupProxy;
  return n("div", { class: t.fileListIconStyles["file-picker__file-icon"], style: t.canLoadPreview ? { backgroundImage: `url(${t.previewURL})` } : void 0 }, [t.canLoadPreview ? e._e() : [t.isFile ? n(t.IconFile, { attrs: { size: 20 } }) : n(t.IconFolder, { attrs: { size: 20 } })]], 2);
}, Fe = [], Se = /* @__PURE__ */ o.normalizeComponent(
  be,
  ke,
  Fe,
  !1,
  null,
  null,
  null,
  null
);
const Ne = Se.exports, $e = /* @__PURE__ */ r.defineComponent({
  __name: "FileListRow",
  props: {
    allowPickDirectory: { type: Boolean },
    selected: { type: Boolean },
    showCheckbox: { type: Boolean },
    canPick: { type: Boolean },
    node: null,
    cropImagePreviews: { type: Boolean }
  },
  emits: ["update:selected", "enter-directory"],
  setup(l, { emit: e }) {
    const n = l, t = r.computed(() => n.node.attributes?.displayName || n.node.basename.slice(0, n.node.extension ? -n.node.extension.length : void 0)), i = r.computed(() => n.node.extension), s = r.computed(() => n.node.type === C.FileType.Folder), a = r.computed(() => n.canPick && (n.allowPickDirectory || !s.value));
    function w() {
      e("update:selected", !n.selected);
    }
    function v() {
      s.value ? e("enter-directory", n.node) : w();
    }
    function d(c) {
      c.key === "Enter" && v();
    }
    return { __sfc: !0, props: n, emit: e, displayName: t, fileExtension: i, isDirectory: s, isPickable: a, toggleSelected: w, handleClick: v, handleKeyDown: d, formatFileSize: C.formatFileSize, NcCheckboxRadioSwitch: k.NcCheckboxRadioSwitch, NcDateTime: k.NcDateTime, t: o.t, FilePreview: Ne };
  }
});
var xe = function() {
  var e = this, n = e._self._c, t = e._self._setupProxy;
  return n("tr", e._g({ class: ["file-picker__row", {
    "file-picker__row--selected": e.selected && !e.showCheckbox
  }], attrs: { tabindex: e.showCheckbox && !t.isDirectory ? void 0 : 0, "aria-selected": t.isPickable ? e.selected : void 0, "data-filename": e.node.basename, "data-testid": "file-list-row" } }, {
    click: t.handleClick,
    /* same as tabindex -> if we hide the checkbox or this is a directory we need keyboard access to enter the directory or select the node */
    ...!e.showCheckbox || t.isDirectory ? { keydown: t.handleKeyDown } : {}
  }), [e.showCheckbox ? n("td", { staticClass: "row-checkbox", on: { click: function(i) {
    return i.stopPropagation(), (() => {
    }).apply(null, arguments);
  } } }, [n(t.NcCheckboxRadioSwitch, { attrs: { "aria-label": t.t("Select the row for {nodename}", { nodename: t.displayName }), checked: e.selected, disabled: !t.isPickable, "data-testid": "row-checkbox" }, on: { "update:checked": t.toggleSelected } })], 1) : e._e(), n("td", { staticClass: "row-name" }, [n("div", { staticClass: "file-picker__name-container", attrs: { "data-testid": "row-name" } }, [n(t.FilePreview, { attrs: { node: e.node, "crop-image-previews": e.cropImagePreviews } }), n("div", { staticClass: "file-picker__file-name", attrs: { title: t.displayName }, domProps: { textContent: e._s(t.displayName) } }), n("div", { staticClass: "file-picker__file-extension", domProps: { textContent: e._s(t.fileExtension) } })], 1)]), n("td", { staticClass: "row-size" }, [e._v(" " + e._s(t.formatFileSize(e.node.size || 0)) + " ")]), n("td", { staticClass: "row-modified" }, [n(t.NcDateTime, { attrs: { timestamp: e.node.mtime, "ignore-seconds": !0 } })], 1)]);
}, ze = [], Be = /* @__PURE__ */ o.normalizeComponent(
  $e,
  xe,
  ze,
  !1,
  null,
  "48df4f27",
  null,
  null
);
const Pe = Be.exports, Ie = /* @__PURE__ */ r.defineComponent({
  __name: "FileList",
  props: {
    currentView: null,
    multiselect: { type: Boolean },
    allowPickDirectory: { type: Boolean },
    loading: { type: Boolean },
    files: null,
    selectedFiles: null,
    path: null
  },
  emits: ["update:path", "update:selectedFiles"],
  setup(l, { emit: e }) {
    const n = l, t = r.ref(), { currentConfig: i } = ee(n.currentView), s = r.computed(() => t.value ?? i.value), a = r.computed(() => s.value.sortBy === "basename" ? s.value.order === "none" ? void 0 : s.value.order : void 0), w = r.computed(() => s.value.sortBy === "size" ? s.value.order === "none" ? void 0 : s.value.order : void 0), v = r.computed(() => s.value.sortBy === "mtime" ? s.value.order === "none" ? void 0 : s.value.order : void 0), d = (u) => {
      s.value.sortBy === u ? s.value.order === "ascending" ? t.value = { sortBy: s.value.sortBy, order: "descending" } : t.value = { sortBy: s.value.sortBy, order: "ascending" } : t.value = { sortBy: u, order: "ascending" };
    }, { sortFavoritesFirst: c, cropImagePreviews: p } = T(), z = r.computed(
      () => {
        const u = {
          ascending: (m, f, B) => B(m, f),
          descending: (m, f, B) => B(f, m),
          // eslint-disable-next-line @typescript-eslint/no-unused-vars
          none: (m, f, B) => 0
        }, b = {
          basename: (m, f) => (m.attributes?.displayName || m.basename).localeCompare(f.attributes?.displayName || f.basename, O.getCanonicalLocale()),
          size: (m, f) => (m.size || 0) - (f.size || 0),
          // reverted because "young" is smaller than "old"
          mtime: (m, f) => (f.mtime?.getTime?.() || 0) - (m.mtime?.getTime?.() || 0)
        };
        return [...n.files].sort(
          (m, f) => (
            // Folders always come above the files
            (f.type === C.FileType.Folder ? 1 : 0) - (m.type === C.FileType.Folder ? 1 : 0) || (c ? (f.attributes.favorite ? 1 : 0) - (m.attributes.favorite ? 1 : 0) : 0) || u[s.value.order](m, f, b[s.value.sortBy])
          )
        );
      }
    ), F = r.computed(() => n.files.filter((u) => n.allowPickDirectory || u.type !== C.FileType.Folder)), $ = r.computed(() => !n.loading && n.selectedFiles.length > 0 && n.selectedFiles.length >= F.value.length);
    function h() {
      n.selectedFiles.length < F.value.length ? e("update:selectedFiles", F.value) : e("update:selectedFiles", []);
    }
    function y(u) {
      n.selectedFiles.includes(u) ? e("update:selectedFiles", n.selectedFiles.filter((b) => b.path !== u.path)) : n.multiselect ? e("update:selectedFiles", [...n.selectedFiles, u]) : e("update:selectedFiles", [u]);
    }
    function S(u) {
      e("update:path", u.path);
    }
    const x = r.ref(4), N = r.ref();
    {
      const u = () => r.nextTick(() => {
        const b = N.value?.parentElement?.children || [];
        let m = N.value?.parentElement?.clientHeight || 450;
        for (let f = 0; f < b.length; f++)
          N.value?.isSameNode(b[f]) || (m -= b[f].clientHeight);
        x.value = Math.floor((m - 50) / 50);
      });
      r.onMounted(() => {
        window.addEventListener("resize", u), u();
      }), r.onUnmounted(() => {
        window.removeEventListener("resize", u);
      });
    }
    return { __sfc: !0, props: n, emit: e, customSortingConfig: t, filesAppSorting: i, sortingConfig: s, sortByName: a, sortBySize: w, sortByModified: v, toggleSorting: d, sortFavoritesFirst: c, cropImagePreviews: p, sortedFiles: z, selectableFiles: F, allSelected: $, onSelectAll: h, onNodeSelected: y, onChangeDirectory: S, skeletonNumber: x, fileContainer: N, NcButton: k.NcButton, NcCheckboxRadioSwitch: k.NcCheckboxRadioSwitch, t: o.t, IconSortAscending: se, IconSortDescending: ue, LoadingTableRow: me, FileListRow: Pe };
  }
});
var Le = function() {
  var e = this, n = e._self._c, t = e._self._setupProxy;
  return n("div", { ref: "fileContainer", staticClass: "file-picker__files" }, [n("table", [n("thead", [n("tr", [e.multiselect ? n("th", { staticClass: "row-checkbox" }, [n("span", { staticClass: "hidden-visually" }, [e._v(" " + e._s(t.t("Select entry")) + " ")]), e.multiselect ? n(t.NcCheckboxRadioSwitch, { attrs: { "aria-label": t.t("Select all entries"), checked: t.allSelected, "data-testid": "select-all-checkbox" }, on: { "update:checked": t.onSelectAll } }) : e._e()], 1) : e._e(), n("th", { staticClass: "row-name", attrs: { "aria-sort": t.sortByName } }, [n("div", { staticClass: "header-wrapper" }, [n("span", { staticClass: "file-picker__header-preview" }), n(t.NcButton, { attrs: { wide: !0, type: "tertiary", "data-test": "file-picker_sort-name" }, on: { click: function(i) {
    return t.toggleSorting("basename");
  } }, scopedSlots: e._u([{ key: "icon", fn: function() {
    return [t.sortByName === "ascending" ? n(t.IconSortAscending, { attrs: { size: 20 } }) : t.sortByName === "descending" ? n(t.IconSortDescending, { attrs: { size: 20 } }) : n("span", { staticStyle: { width: "44px" } })];
  }, proxy: !0 }]) }, [e._v(" " + e._s(t.t("Name")) + " ")])], 1)]), n("th", { staticClass: "row-size", attrs: { "aria-sort": t.sortBySize } }, [n(t.NcButton, { attrs: { wide: !0, type: "tertiary" }, on: { click: function(i) {
    return t.toggleSorting("size");
  } }, scopedSlots: e._u([{ key: "icon", fn: function() {
    return [t.sortBySize === "ascending" ? n(t.IconSortAscending, { attrs: { size: 20 } }) : t.sortBySize === "descending" ? n(t.IconSortDescending, { attrs: { size: 20 } }) : n("span", { staticStyle: { width: "44px" } })];
  }, proxy: !0 }]) }, [e._v(" " + e._s(t.t("Size")) + " ")])], 1), n("th", { staticClass: "row-modified", attrs: { "aria-sort": t.sortByModified } }, [n(t.NcButton, { attrs: { wide: !0, type: "tertiary" }, on: { click: function(i) {
    return t.toggleSorting("mtime");
  } }, scopedSlots: e._u([{ key: "icon", fn: function() {
    return [t.sortByModified === "ascending" ? n(t.IconSortAscending, { attrs: { size: 20 } }) : t.sortByModified === "descending" ? n(t.IconSortDescending, { attrs: { size: 20 } }) : n("span", { staticStyle: { width: "44px" } })];
  }, proxy: !0 }]) }, [e._v(" " + e._s(t.t("Modified")) + " ")])], 1)])]), n("tbody", [e.loading ? e._l(t.skeletonNumber, function(i) {
    return n(t.LoadingTableRow, { key: i, attrs: { "show-checkbox": e.multiselect } });
  }) : e._l(t.sortedFiles, function(i) {
    return n(t.FileListRow, { key: i.fileid || i.path, attrs: { "allow-pick-directory": e.allowPickDirectory, "show-checkbox": e.multiselect, "can-pick": e.multiselect || e.selectedFiles.length === 0 || e.selectedFiles.includes(i), selected: e.selectedFiles.includes(i), node: i, "crop-image-previews": t.cropImagePreviews }, on: { "update:selected": function(s) {
      return t.onNodeSelected(i);
    }, "enter-directory": t.onChangeDirectory } });
  })], 2)])]);
}, Ve = [], Re = /* @__PURE__ */ o.normalizeComponent(
  Ie,
  Le,
  Ve,
  !1,
  null,
  "d3c94818",
  null,
  null
);
const De = Re.exports, Me = {
  name: "HomeIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var He = function() {
  var e = this, n = e._self._c;
  return n("span", e._b({ staticClass: "material-design-icon home-icon", attrs: { "aria-hidden": e.title ? null : !0, "aria-label": e.title, role: "img" }, on: { click: function(t) {
    return e.$emit("click", t);
  } } }, "span", e.$attrs, !1), [n("svg", { staticClass: "material-design-icon__svg", attrs: { fill: e.fillColor, width: e.size, height: e.size, viewBox: "0 0 24 24" } }, [n("path", { attrs: { d: "M10,20V14H14V20H19V12H22L12,3L2,12H5V20H10Z" } }, [e.title ? n("title", [e._v(e._s(e.title))]) : e._e()])])]);
}, Ae = [], Te = /* @__PURE__ */ o.normalizeComponent(
  Me,
  He,
  Ae,
  !1,
  null,
  null,
  null,
  null
);
const Ue = Te.exports, qe = {
  name: "PlusIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var Ee = function() {
  var e = this, n = e._self._c;
  return n("span", e._b({ staticClass: "material-design-icon plus-icon", attrs: { "aria-hidden": e.title ? null : !0, "aria-label": e.title, role: "img" }, on: { click: function(t) {
    return e.$emit("click", t);
  } } }, "span", e.$attrs, !1), [n("svg", { staticClass: "material-design-icon__svg", attrs: { fill: e.fillColor, width: e.size, height: e.size, viewBox: "0 0 24 24" } }, [n("path", { attrs: { d: "M19,13H13V19H11V13H5V11H11V5H13V11H19V13Z" } }, [e.title ? n("title", [e._v(e._s(e.title))]) : e._e()])])]);
}, Oe = [], Ze = /* @__PURE__ */ o.normalizeComponent(
  qe,
  Ee,
  Oe,
  !1,
  null,
  null,
  null,
  null
);
const je = Ze.exports, Ge = /* @__PURE__ */ r.defineComponent({
  __name: "FilePickerBreadcrumbs",
  props: {
    path: null,
    showMenu: { type: Boolean }
  },
  emits: ["update:path", "create-node"],
  setup(l, { emit: e }) {
    const n = l, t = r.ref(!1), i = r.ref(""), s = r.ref();
    function a() {
      const d = i.value.trim(), c = s.value?.$el?.querySelector("input");
      let p = "";
      return d.length === 0 ? p = o.t("Folder name cannot be empty.") : d.includes("/") ? p = o.t('"/" is not allowed inside a folder name.') : ["..", "."].includes(d) ? p = o.t('"{name}" is an invalid folder name.', { name: d }) : window.OC.config?.blacklist_files_regex && d.match(window.OC.config?.blacklist_files_regex) && (p = o.t('"{name}" is not an allowed folder name', { name: d })), c && c.setCustomValidity(p), p === "";
    }
    const w = function() {
      const d = i.value.trim();
      a() && (t.value = !1, e("create-node", d), i.value = "");
    }, v = r.computed(
      () => n.path.split("/").filter((d) => d !== "").map((d, c, p) => ({
        name: d,
        path: "/" + p.slice(0, c + 1).join("/")
      }))
    );
    return { __sfc: !0, props: n, emit: e, actionsOpen: t, newNodeName: i, nameInput: s, validateInput: a, onSubmit: w, pathElements: v, IconFolder: q, IconHome: Ue, IconPlus: je, NcActions: k.NcActions, NcActionInput: k.NcActionInput, NcBreadcrumbs: k.NcBreadcrumbs, NcBreadcrumb: k.NcBreadcrumb, t: o.t };
  }
});
var We = function() {
  var e = this, n = e._self._c, t = e._self._setupProxy;
  return n(t.NcBreadcrumbs, { staticClass: "file-picker__breadcrumbs", scopedSlots: e._u([{ key: "default", fn: function() {
    return [n(t.NcBreadcrumb, { attrs: { name: t.t("All files"), title: t.t("Home") }, on: { click: function(i) {
      return t.emit("update:path", "/");
    } }, scopedSlots: e._u([{ key: "icon", fn: function() {
      return [n(t.IconHome, { attrs: { size: 20 } })];
    }, proxy: !0 }]) }), e._l(t.pathElements, function(i) {
      return n(t.NcBreadcrumb, { key: i.path, attrs: { name: i.name, title: i.path }, on: { click: function(s) {
        return t.emit("update:path", i.path);
      } } });
    })];
  }, proxy: !0 }, e.showMenu ? { key: "actions", fn: function() {
    return [n(t.NcActions, { attrs: { "aria-label": t.t("Create directory"), "force-menu": !0, "force-name": !0, "menu-name": t.t("New"), open: t.actionsOpen, type: "secondary" }, on: { "update:open": function(i) {
      t.actionsOpen = i;
    }, close: function(i) {
      t.newNodeName = "";
    } }, scopedSlots: e._u([{ key: "icon", fn: function() {
      return [n(t.IconPlus, { attrs: { size: 20 } })];
    }, proxy: !0 }], null, !1, 2971667417) }, [n(t.NcActionInput, { ref: "nameInput", attrs: { value: t.newNodeName, label: t.t("New folder"), placeholder: t.t("New folder name") }, on: { "update:value": function(i) {
      t.newNodeName = i;
    }, submit: t.onSubmit, input: t.validateInput }, scopedSlots: e._u([{ key: "icon", fn: function() {
      return [n(t.IconFolder, { attrs: { size: 20 } })];
    }, proxy: !0 }], null, !1, 1614167509) })], 1)];
  }, proxy: !0 } : null], null, !0) });
}, Ke = [], Je = /* @__PURE__ */ o.normalizeComponent(
  Ge,
  We,
  Ke,
  !1,
  null,
  "22cbb5df",
  null,
  null
);
const Qe = Je.exports, Xe = {
  name: "CloseIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var Ye = function() {
  var e = this, n = e._self._c;
  return n("span", e._b({ staticClass: "material-design-icon close-icon", attrs: { "aria-hidden": e.title ? null : !0, "aria-label": e.title, role: "img" }, on: { click: function(t) {
    return e.$emit("click", t);
  } } }, "span", e.$attrs, !1), [n("svg", { staticClass: "material-design-icon__svg", attrs: { fill: e.fillColor, width: e.size, height: e.size, viewBox: "0 0 24 24" } }, [n("path", { attrs: { d: "M19,6.41L17.59,5L12,10.59L6.41,5L5,6.41L10.59,12L5,17.59L6.41,19L12,13.41L17.59,19L19,17.59L13.41,12L19,6.41Z" } }, [e.title ? n("title", [e._v(e._s(e.title))]) : e._e()])])]);
}, et = [], tt = /* @__PURE__ */ o.normalizeComponent(
  Xe,
  Ye,
  et,
  !1,
  null,
  null,
  null,
  null
);
const nt = tt.exports, it = {
  name: "MagnifyIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var rt = function() {
  var e = this, n = e._self._c;
  return n("span", e._b({ staticClass: "material-design-icon magnify-icon", attrs: { "aria-hidden": e.title ? null : !0, "aria-label": e.title, role: "img" }, on: { click: function(t) {
    return e.$emit("click", t);
  } } }, "span", e.$attrs, !1), [n("svg", { staticClass: "material-design-icon__svg", attrs: { fill: e.fillColor, width: e.size, height: e.size, viewBox: "0 0 24 24" } }, [n("path", { attrs: { d: "M9.5,3A6.5,6.5 0 0,1 16,9.5C16,11.11 15.41,12.59 14.44,13.73L14.71,14H15.5L20.5,19L19,20.5L14,15.5V14.71L13.73,14.44C12.59,15.41 11.11,16 9.5,16A6.5,6.5 0 0,1 3,9.5A6.5,6.5 0 0,1 9.5,3M9.5,5C7,5 5,7 5,9.5C5,12 7,14 9.5,14C12,14 14,12 14,9.5C14,7 12,5 9.5,5Z" } }, [e.title ? n("title", [e._v(e._s(e.title))]) : e._e()])])]);
}, st = [], lt = /* @__PURE__ */ o.normalizeComponent(
  it,
  rt,
  st,
  !1,
  null,
  null,
  null,
  null
);
const ot = lt.exports;
/**
 * @copyright Copyright (c) 2024 Ferdinand Thiessen <opensource@fthiessen.de>
 *
 * @author Ferdinand Thiessen <opensource@fthiessen.de>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
const at = (l) => {
  const e = [
    {
      id: "files",
      label: o.t("All files"),
      icon: I.mdiFolder
    },
    {
      id: "recent",
      label: o.t("Recent"),
      icon: I.mdiClock
    },
    {
      id: "favorites",
      label: o.t("Favorites"),
      icon: I.mdiStar
    }
  ], n = l.value ? e.filter(({ id: t }) => t === "files") : e;
  return {
    allViews: e,
    availableViews: n
  };
}, ct = /* @__PURE__ */ r.defineComponent({
  __name: "FilePickerNavigation",
  props: {
    currentView: null,
    filterString: null,
    isCollapsed: { type: Boolean },
    disabledNavigation: { type: Boolean }
  },
  emits: ["update:currentView", "update:filterString"],
  setup(l, { emit: e }) {
    const n = l, { availableViews: t } = at(r.ref(j.getCurrentUser() === null)), i = r.computed(() => t.filter((a) => a.id === n.currentView)[0] ?? t[0]);
    return { __sfc: !0, props: n, emit: e, availableViews: t, currentViewObject: i, updateFilterValue: (a) => e("update:filterString", a), IconClose: nt, IconMagnify: ot, NcButton: k.NcButton, NcIconSvgWrapper: k.NcIconSvgWrapper, NcSelect: k.NcSelect, NcTextField: k.NcTextField, Fragment: G.Fragment, t: o.t };
  }
});
var ut = function() {
  var e = this, n = e._self._c, t = e._self._setupProxy;
  return n(t.Fragment, [n(t.NcTextField, { staticClass: "file-picker__filter-input", attrs: { value: e.filterString, label: t.t("Filter file list"), "show-trailing-button": !!e.filterString }, on: { "update:value": t.updateFilterValue, "trailing-button-click": function(i) {
    return t.updateFilterValue("");
  } }, scopedSlots: e._u([{ key: "trailing-button-icon", fn: function() {
    return [n(t.IconClose, { attrs: { size: 16 } })];
  }, proxy: !0 }]) }, [n(t.IconMagnify, { attrs: { size: 16 } })], 1), t.availableViews.length > 1 && !e.disabledNavigation ? [e.isCollapsed ? n(t.NcSelect, { attrs: { "aria-label": t.t("Current view selector"), clearable: !1, searchable: !1, options: t.availableViews, value: t.currentViewObject }, on: { input: (i) => t.emit("update:currentView", i.id) } }) : n("ul", { staticClass: "file-picker__side" }, e._l(t.availableViews, function(i) {
    return n("li", { key: i.id }, [n(t.NcButton, { attrs: { type: e.currentView === i.id ? "primary" : "tertiary", wide: !0 }, on: { click: function(s) {
      return e.$emit("update:currentView", i.id);
    } }, scopedSlots: e._u([{ key: "icon", fn: function() {
      return [n(t.NcIconSvgWrapper, { attrs: { path: i.icon, size: 20 } })];
    }, proxy: !0 }], null, !0) }, [e._v(" " + e._s(i.label) + " ")])], 1);
  }), 0)] : e._e()], 2);
}, dt = [], ft = /* @__PURE__ */ o.normalizeComponent(
  ct,
  ut,
  dt,
  !1,
  null,
  "a06474d4",
  null,
  null
);
const pt = ft.exports;
/**
 * @copyright Copyright (c) 2023 Ferdinand Thiessen <opensource@fthiessen.de>
 *
 * @author Ferdinand Thiessen <opensource@fthiessen.de>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const _t = function(l, e, n) {
  const t = r.computed(() => n.value ? "/" : C.davRootPath), i = r.computed(() => n.value ? P.generateRemoteUrl("webdav").replace("/remote.php", "/public.php") : C.davRemoteURL), s = r.computed(() => {
    if (n.value) {
      const h = document.getElementById("sharingToken").value, y = btoa(`${h}:null`);
      return C.davGetClient(i.value, {
        Authorization: `Basic ${y}`
      });
    }
    return C.davGetClient();
  }), a = (h) => C.davResultToNode(h, t.value, i.value), w = () => {
    const h = new AbortController(), y = Math.round(Date.now() / 1e3) - 60 * 60 * 24 * 14;
    return new D.CancelablePromise(async (S, x, N) => {
      N(() => h.abort());
      try {
        const { data: u } = await s.value.search("/", {
          signal: h.signal,
          details: !0,
          data: C.davGetRecentSearch(y)
        }), b = u.results.map(a);
        S(b);
      } catch (u) {
        x(u);
      }
    });
  }, v = () => {
    const h = new AbortController();
    return new D.CancelablePromise(async (y, S, x) => {
      x(() => h.abort());
      try {
        let u = (await s.value.getDirectoryContents(`${t.value}${e.value}`, {
          signal: h.signal,
          details: !0,
          data: C.davGetDefaultPropfind()
        })).data.map(a);
        n.value && (u = u.filter((b) => b.path !== e.value)), y(u);
      } catch (N) {
        S(N);
      }
    });
  }, d = r.ref([]), c = r.ref(!0), p = r.ref(null);
  async function z(h) {
    const y = R.join(e.value, h);
    await s.value.createDirectory(R.join(t.value, y));
    const S = await F(y);
    return d.value.push(S), S;
  }
  async function F(h, y = void 0) {
    y = y ?? t.value;
    const { data: S } = await s.value.stat(`${y}${h}`, {
      details: !0,
      data: C.davGetDefaultPropfind()
    });
    return a(S);
  }
  async function $() {
    p.value && p.value.cancel(), c.value = !0, l.value === "favorites" ? p.value = C.getFavoriteNodes(s.value, e.value, t.value) : l.value === "recent" ? p.value = w() : p.value = v(), d.value = await p.value, p.value = null, c.value = !1;
  }
  return r.watch([l, e], () => $()), r.onMounted(() => $()), {
    isLoading: c,
    files: d,
    loadFiles: $,
    getFile: F,
    createDirectory: z
  };
};
/**
 * @copyright Copyright (c) 2023 Ferdinand Thiessen <opensource@fthiessen.de>
 *
 * @author Ferdinand Thiessen <opensource@fthiessen.de>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const mt = function(l) {
  const e = r.computed(() => l.value.map((t) => t.split("/")));
  return {
    isSupportedMimeType: (t) => {
      const i = t.split("/");
      return e.value.some(
        ([s, a]) => (
          // check mime type matches or is wildcard
          (i[0] === s || s === "*") && (i[1] === a || a === "*")
        )
      );
    }
  };
}, vt = {
  name: "FilePicker"
}, gt = /* @__PURE__ */ r.defineComponent({
  ...vt,
  props: {
    buttons: null,
    name: null,
    allowPickDirectory: { type: Boolean, default: !1 },
    disabledNavigation: { type: Boolean, default: !1 },
    container: { default: "body" },
    filterFn: { default: void 0 },
    mimetypeFilter: { default: () => [] },
    multiselect: { type: Boolean, default: !0 },
    path: { default: void 0 }
  },
  emits: ["close"],
  setup(l, { emit: e }) {
    const n = l, { isPublic: t } = L(), i = r.ref(!0), s = r.computed(() => (typeof n.buttons == "function" ? n.buttons(c.value, F.value, v.value) : n.buttons).map((g) => ({
      ...g,
      callback: () => {
        a = !0, w(g.callback);
      }
    })));
    let a = !1;
    const w = async (_) => {
      const g = c.value.length === 0 && n.allowPickDirectory ? [await N(F.value)] : c.value;
      _(g), e("close", g), a = !1;
    }, v = r.ref("files"), d = r.computed(() => v.value === "favorites" ? o.t("Favorites") : v.value === "recent" ? o.t("Recent") : ""), c = r.ref([]), p = r.ref(window?.sessionStorage.getItem("NC.FilePicker.LastPath") || "/"), z = r.ref(), F = r.computed({
      // Only use the path for the files view as favorites and recent only works on the root
      get: () => v.value === "files" ? z.value || n.path || p.value : "/",
      /**
       * Navigate to the new path and save it to the session storage
       *
       * @param path The new path
       */
      set: (_) => {
        n.path === void 0 && window.sessionStorage.setItem("NC.FilePicker.LastPath", _), z.value = _, c.value = [];
      }
    }), $ = r.ref(""), { isSupportedMimeType: h } = mt(r.toRef(n, "mimetypeFilter")), { files: y, isLoading: S, loadFiles: x, getFile: N, createDirectory: u } = _t(v, F, t);
    r.onMounted(() => x());
    const { showHiddenFiles: b } = T(), m = r.computed(() => {
      let _ = y.value;
      return b.value || (_ = _.filter((g) => !g.basename.startsWith("."))), n.mimetypeFilter.length > 0 && (_ = _.filter((g) => g.type === "folder" || g.mime && h(g.mime))), $.value && (_ = _.filter((g) => g.basename.toLowerCase().includes($.value.toLowerCase()))), n.filterFn && (_ = _.filter((g) => n.filterFn(g))), _;
    }), f = r.computed(() => v.value === "files" ? o.t("Upload some content or sync with your devices!") : v.value === "recent" ? o.t("Files and folders you recently modified will show up here.") : o.t("Files and folders you mark as favorite will show up here."));
    return { __sfc: !0, props: n, emit: e, isPublic: t, isOpen: i, dialogButtons: s, isHandlingCallback: a, handleButtonClick: w, currentView: v, viewHeadline: d, selectedFiles: c, savedPath: p, navigatedPath: z, currentPath: F, filterString: $, isSupportedMimeType: h, files: y, isLoading: S, loadFiles: x, getFile: N, createDirectory: u, showHiddenFiles: b, filteredFiles: m, noFilesDescription: f, onCreateFolder: async (_) => {
      try {
        const g = await u(_);
        F.value = g.path, W.emit("files:node:created", y.value.filter((E) => E.basename === _)[0]);
      } catch (g) {
        console.warn("Could not create new folder", { name: _, error: g }), o.showError(o.t("Could not create the new folder"));
      }
    }, handleClose: (_) => {
      !_ && !a && e("close");
    }, IconFile: A, FileList: De, FilePickerBreadcrumbs: Qe, FilePickerNavigation: pt, NcDialog: k.NcDialog, NcEmptyContent: k.NcEmptyContent, t: o.t };
  }
});
var ht = function() {
  var e = this, n = e._self._c, t = e._self._setupProxy;
  return n(t.NcDialog, { attrs: { container: e.container, buttons: t.dialogButtons, name: e.name, size: "large", "content-classes": "file-picker__content", "dialog-classes": "file-picker", "navigation-classes": "file-picker__navigation", open: t.isOpen }, on: { "update:open": [function(i) {
    t.isOpen = i;
  }, t.handleClose] }, scopedSlots: e._u([{ key: "navigation", fn: function({ isCollapsed: i }) {
    return [n(t.FilePickerNavigation, { attrs: { "is-collapsed": i, "current-view": t.currentView, "filter-string": t.filterString, "disabled-navigation": e.disabledNavigation }, on: { "update:currentView": function(s) {
      t.currentView = s;
    }, "update:current-view": function(s) {
      t.currentView = s;
    }, "update:filterString": function(s) {
      t.filterString = s;
    }, "update:filter-string": function(s) {
      t.filterString = s;
    } } })];
  } }]) }, [n("div", { staticClass: "file-picker__main" }, [t.currentView === "files" ? n(t.FilePickerBreadcrumbs, { attrs: { path: t.currentPath, "show-menu": e.allowPickDirectory }, on: { "update:path": function(i) {
    t.currentPath = i;
  }, "create-node": t.onCreateFolder } }) : n("div", { staticClass: "file-picker__view" }, [n("h3", [e._v(e._s(t.viewHeadline))])]), t.isLoading || t.filteredFiles.length > 0 ? n(t.FileList, { attrs: { "allow-pick-directory": e.allowPickDirectory, "current-view": t.currentView, files: t.filteredFiles, multiselect: e.multiselect, loading: t.isLoading, path: t.currentPath, "selected-files": t.selectedFiles, name: t.viewHeadline }, on: { "update:path": [function(i) {
    t.currentPath = i;
  }, function(i) {
    t.currentView = "files";
  }], "update:selectedFiles": function(i) {
    t.selectedFiles = i;
  }, "update:selected-files": function(i) {
    t.selectedFiles = i;
  } } }) : t.filterString ? n(t.NcEmptyContent, { attrs: { name: t.t("No matching files"), description: t.t("No files matching your filter were found.") }, scopedSlots: e._u([{ key: "icon", fn: function() {
    return [n(t.IconFile)];
  }, proxy: !0 }]) }) : n(t.NcEmptyContent, { attrs: { name: t.t("No files in here"), description: t.noFilesDescription }, scopedSlots: e._u([{ key: "icon", fn: function() {
    return [n(t.IconFile)];
  }, proxy: !0 }]) })], 1)]);
}, yt = [], wt = /* @__PURE__ */ o.normalizeComponent(
  gt,
  ht,
  yt,
  !1,
  null,
  "6ff1b36b",
  null,
  null
);
const Ct = wt.exports;
exports.default = Ct;
