/**
 * Returns the user's locale
 */
export declare function getLocale(): string;
/**
 * Returns user's locale in canonical form
 * E.g. `en-US` instead of `en_US`
 */
export declare function getCanonicalLocale(): string;
/**
 * Returns the user's language
 */
export declare function getLanguage(): string;
/**
 * Check whether the current, or a given, language is read right-to-left
 *
 * @param language Language code to check, defaults to current language
 */
export declare function isRTL(language?: string): boolean;
