/**
 * URI-Encodes a file path but keep the path slashes.
 */
export declare function encodePath(path: string): string;
/**
 * Returns the base name of the given path.
 * For example for "/abc/somefile.txt" it will return "somefile.txt"
 */
export declare function basename(path: string): string;
/**
 * Returns the dir name of the given path.
 * For example for "/abc/somefile.txt" it will return "/abc"
 */
export declare function dirname(path: string): string;
/**
 * Join path sections
 */
export declare function joinPaths(...args: string[]): string;
/**
 * Returns whether the given paths are the same, without
 * leading, trailing or doubled slashes and also removing
 * the dot sections.
 */
export declare function isSamePath(path1: string, path2: string): boolean;
